#include <iostream>
#include <algorithm>
#include <cassert>
#include <ctime>
#include <cmath>
#include <vector>
#include <map>
#include <set>
#include <array>
#include <iomanip>
#include <unordered_map>
#include <utility>
#include <unordered_set>
#include <bitset>
#include <random>
#include <chrono>
// #include <bits/stdc++.h>
#define sz(_a) ((int)(_a).size())

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> par;
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

#ifdef MAKS
#define deb(a) #a << '\t' << a
#else
#define deb(a) ""
#endif // MAKS



template <typename K, typename L>
std::ostream& operator<<(std::ostream& os, const pair<K, L>& p) {
#ifdef MAKS
    os << '(';
#endif // MAKS
    os << p.first << ' ' << p.second;
#ifdef MAKS
    os << ')';
#endif // MAKS
    return os;
}

template <template <class, class...> class C, typename K, typename... Args,
    typename std::enable_if<!std::is_same<K, char>::value>::type* = nullptr>
std::ostream& operator<<(std::ostream& os, const C<K, Args...>& a) {
#ifdef MAKS
    if (!sz(a)) {
        os << 'E';
    }
#endif // MAKS
    for (const auto& i : a) {
        os << i << ' ';
    }
    os << '\n';
    return os;
}























const int M = 998244353;

inline signed solve() {

    int n;
    cin >> n;
    vector<int> h(n);
    for (int& i : h) {
        cin >> i;
    }
    vector<par> pr;
    for (int i = 0; i < n; ++i) {
        int p;
        cin >> p;
        pr.emplace_back(p, h[i]);
        if (h[i] > p) {
            return cout << "-1\n", 0;
        }
    }
    sort(pr.begin(), pr.end());
    pr.resize(unique(pr.begin(), pr.end()) - pr.begin());
    int prev_f = -1;
    int prev_s = 0;
    for (auto [f, s] : pr) {
        if (f == prev_f || prev_s > s) {
            return cout << "-1\n", 0;
        }
        prev_f = f;
        prev_s = s;
    }
    cout << prev_f - prev_s << '\n';


    return 0;
}


signed main() {
#ifdef MAKS
    double start = clock();
    freopen("in.txt", "r", stdin);
#endif // MAKS
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(11);
    cerr << fixed << setprecision(3);

    int t_t = 1;
    cin >> t_t;
    while (t_t--) {
        solve();
    }

#ifdef MAKS
    cerr << "\nTime: " << (clock() - start) * 1000.0 / CLOCKS_PER_SEC << "ms\n";
#endif // MAKS
    return 0;
}
