﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>
#include <bitset>

#define all(v) v.begin(),v.end()

using namespace std;
typedef long long ll;
const long long MOD = 998244353;
const long long MAXN = 100000;

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(9);

#ifdef TEAM
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
}

ll gcd(ll x, ll y) {
    while (y) {
        x %= y;
        swap(x, y);
    }
    return x;
}

ll binpow(ll a, ll k, ll mod = 1e9 + 7) {
    ll res = 1;
    ll t = a;
    while (k) {
        if (k % 2)
            res = (res * t) % mod;
        t = (t * t) % mod;
        k /= 2;
    }
    return res;
}

ll rev(ll a, ll mod = MOD) {
    return binpow(a, mod - 2, mod);
}

/*
ll fact[MAXN];
ll revf[MAXN];
void prec() {
    ll c=1;
    fact[0] = 1;
    for (size_t i = 1; i < MAXN; ++i)
    {
        fact[i] = (fact[i - 1] * i)%MOD;
    }
    revf[MAXN - 1] = rev(fact[MAXN - 1]);
    for (int i = MAXN - 2; i >= 0; i--)
    {
        revf[i] = (revf[i + 1] * (i+1)) % MOD;
    }
}
*/

void solve() {
    ll n, m, k;
    string s;
    cin >> n >> m >> k >> s;
    int ss = 0;
    for (int i = 0; i < k; ++i) {
        ss *= 2;
        ss += s[i] - '0';
    }
    if (m > n) {
        swap(n, m);
    }
    if (n == k) {
        cout << 1;
        return;
    }
    vector<vector<vector<ll>>> dp(n, vector<vector<ll>>(1 << (1 << (k + 1)), vector<ll>(1 << (k + 1), 0)));
    vector<vector<vector<ll>>> dpa(n, vector<vector<ll>>(1 << (1 << (k + 1)), vector<ll>(1 << (k + 1), 0)));
    for (int j = 0; j < (1 << k + 1); ++j) {
        if (j % (1 << k) == ss || j / 2 == ss) {
            dpa[k][1 << j][j] = 1;
            dpa[k - 1][0][ss] = 1;
        }
        else {
            dp[k][1 << j][j] = 1;
        }
    }

    for (int l = k; l < n - 1; ++l) {
        for (int i = 0; i < (1 << (1 << (k + 1))); i++) {
            for (int j = 0; j < (1 << k + 1); ++j) {
                if (i & (1 << j)) {
                    int to = j / 2;
                    if (to % (1 << k) == ss || to / 2 == ss) {
                        dpa[l + 1][i | (1 << to)][to] += dp[l][i][j];
                        dpa[l + 1][i | (1 << to)][to] %= MOD;
                        dpa[l + 1][i | (1 << to)][to] += dpa[l][i][j];
                        dpa[l + 1][i | (1 << to)][to] %= MOD;
                    }
                    else {
                        dp[l + 1][i | (1 << to)][to] += dp[l][i][j];
                        dp[l + 1][i | (1 << to)][to] %= MOD;
                        dpa[l + 1][i | (1 << to)][to] += dpa[l][i][j];
                        dpa[l + 1][i | (1 << to)][to] %= MOD;
                    }
                    to += (1 << k);
                    if (to % (1 << k) == ss || to / 2 == ss) {
                        dpa[l + 1][i | (1 << to)][to] += dp[l][i][j];
                        dpa[l + 1][i | (1 << to)][to] %= MOD;
                        dpa[l + 1][i | (1 << to)][to] += dpa[l][i][j];
                        dpa[l + 1][i | (1 << to)][to] %= MOD;
                    }
                    else {
                        dp[l + 1][i | (1 << to)][to] += dp[l][i][j];
                        dp[l + 1][i | (1 << to)][to] %= MOD;
                        dpa[l + 1][i | (1 << to)][to] += dpa[l][i][j];
                        dpa[l + 1][i | (1 << to)][to] %= MOD;
                    }
                }
            }
        }
    }

    ll ans = 0;
    vector<ll> su1((1 << (1 << (k + 1))), 0), su2((1 << (1 << (k + 1))), 0);
    for (int i = 0; i < (1 << (1 << (k + 1))); i++) {
        for (int j = 0; j < (1 << k + 1); ++j) {
            su1[i] += dpa[n - 1][i][j];
            su2[i] += dpa[m - 1][i][j];
            su1[i] %= MOD;
            su2[i] %= MOD;
        }
    }

    for (int i = 0; i < (1 << (1 << (k + 1))); i++) {
        int mask = i;
        while (true) {
            ans = (ans + (su1[mask] * su2[i ^ mask]) % MOD) % MOD;
            if (mask == 0)
                break;
            mask = (mask - 1) & i;
        }
    }
    cout << ans;
}

int main()
{
    
    start();
    ll t = 1;
    //cin >> t;
    while (t--)
    {
        solve();
    }
}
