#include<bits/stdc++.h>

using namespace std;

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

#define int long long

const int kMaxN = 100 + 5;
const int kMod = 998244353;
const int kMaxPow2 = 20;
int pow2[kMaxPow2];

void precalc() {
    pow2[0] = 1;
    for (int x = 1; x < kMaxPow2; ++x) {
        pow2[x] = pow2[x - 1] * 2;
    }
}

void solve() {
    int n, m, k;
    std::cin >> n >> m >> k;
    std::string str;
    std::cin >> str;
    int num = 0;
    for (int i = 0; i < k; ++i) {
        num *= 2;
        num += str[i] - '0';
    }
    std::vector<std::vector<std::vector<int> > > dp(pow2[pow2[k + 1]], std::vector<std::vector<int> >(pow2[k], std::vector<int>(2)));
    std::vector<std::vector<std::vector<int> > > next(pow2[pow2[k + 1]], std::vector<std::vector<int> >(pow2[k], std::vector<int>(2)));
    for (int cur = 0; cur < (1 << k); ++cur) {
        dp[0][cur][cur == num] = 1;
    }
    for (int len = k; len < std::min(n, m); ++len) {
        for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
            for (int cur = 0; cur < (1 << k); ++cur) {
                for (int used = 0; used < 2; ++used) {
                    for (int bit = 0; bit < 2; ++bit) {
                        int new_cur = (cur * 2 + bit) % pow2[k];
                        int new_used = std::max(used, (int)(new_cur == num));
                        int new_mask = (mask | pow2[cur * 2 + bit]);
                        next[new_mask][new_cur][new_used] = (next[new_mask][new_cur][new_used] + dp[mask][cur][used]) % kMod;
                    }
                dp[mask][cur][used] = 0;
                }
            }
        }
        dp.swap(next);
    }
    std::vector<int> copy_sm(pow2[(1 << (k + 1))]);
    for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
        for (int cur = 0; cur < (1 << k); ++cur) {
            copy_sm[mask] = (copy_sm[mask] + dp[mask][cur][1]) % kMod;
        }
    }
    for (int len = std::min(n, m); len < std::max(n, m); ++len) {
        for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
            for (int cur = 0; cur < (1 << k); ++cur) {
                for (int used = 0; used < 2; ++used) {
                    for (int bit = 0; bit < 2; ++bit) {
                        int new_cur = (cur * 2 + bit) % pow2[k];
                        int new_used = std::max(used, (int)(new_cur == num));
                        int new_mask = (mask | pow2[cur * 2 + bit]);
                        next[new_mask][new_cur][new_used] = (next[new_mask][new_cur][new_used] + dp[mask][cur][used]) % kMod;
                    }
                dp[mask][cur][used] = 0;
                }
            }
        }
        dp.swap(next);
    }
    std::vector<int> sm(pow2[(1 << (k + 1))]);
    for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
        for (int cur = 0; cur < (1 << k); ++cur) {
            sm[mask] = (sm[mask] + dp[mask][cur][1]) % kMod;
        }
    }
    for (int bit = 0; bit < (1 << (k + 1)); ++bit) {
        for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
            if ((mask & (1 << bit)) != 0) {
                sm[mask] = (sm[mask] + sm[mask ^ (mask & pow2[bit])]) % kMod;
            }
        }
    }
    int answer = 0;
    for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
        answer = (answer + copy_sm[mask] * sm[(pow2[(1 << (k + 1))] - 1) ^ (mask)]) % kMod;
    }
    std::cout << answer << std::endl;
    return;
}

int32_t main() {
    IOSync();
    precalc();
    int tests = 1;
    // std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
