﻿#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>
#include <time.h>
#include <queue>
#include <stack>
#include <deque>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <bitset>
using namespace std;
#define ll long long
#define ld long double
#define all(h) h.begin(), h.end()
#define rall(h) h.rbegin(), h.rend()
#pragma comment(linker, "/STACK:36777216")
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")
#define X first
#define Y first
mt19937 rnd(time(0));

bool condition(vector<ll> v, ll k, ll n) {
    for (int pw = 0; pw < 31; pw++) {
        for (int i = 0; i < n; i++) {
            if (v[i] < k)
                return false;
            if (((v[i] - k) >> pw) & 1) {
                v[i] -= 1ll << pw;
                v[i + 1] -= 1ll << (pw + 1);
            }
            if (!i)
                v.back() = v[0];
        }
        v[0] = v.back();
    }
    for (int i = 0; i < n; i++)
        if (v[i] != k)
            return false;
    return true;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t; cin >> t;
    while (t--) {
        ll n, k;
        cin >> n;
        vector<ll> v(n);
        for (auto& i : v)
            cin >> i;
        v.push_back(v[0]);
        for (k = 0; k < 3; k++)
            if (condition(v, k, n))
                break;
        ll l = -20, r = 1e9, mid;
        while (r - l > 1) {
            mid = (l + r) / 2;
            if (condition(v, mid * 3 + k, n))
                l = mid;
            else
                r = mid;
        }
        cout << max(0ll, l * 3 + k) << '\n';
    }
}
