#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#ifdef LOCAL
    #define debug(x) cout << (#x) << ": " << (x) << "\n";
#else
    #define debug(x);
#endif

void solve() {
    ll n;
    cin >> n;
    vector<ll> h(n);
    for (int i = 0; i < n; ++i) cin >> h[i];
    vector<ll> p(n);
    for (int i = 0; i < n; ++i) cin >> p[i];

    map<ll, ll> m;
    map<ll, bool> used;
    for (int i = 0; i < n; ++i) {
        if (h[i] > p[i]) {
            cout << -1 << "\n";
            return;
        }

        if (used[p[i]]) {
            if (m[p[i]] != (p[i] - h[i])) {
                cout << -1 << "\n";
                return;
            }
        } else {
            used[p[i]] = true;
            m[p[i]] = p[i] - h[i];
        }
    }

    vector<ll> res;
    vector<ll> ans;
    for (const auto& [k, v] : m) {
        res.push_back(v);
        ans.push_back(k - v);
    }
    ll sz = ans.size();
    for (int i = 1; i < sz; ++i) {
        if ((res[i] < res[i - 1]) || (ans[i] < ans[i - 1])) {
            cout << -1 << "\n";
            return;
        }
    }
    cout << res[sz - 1] << "\n";
}

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    ll t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
