﻿#include <iostream>
#include <string>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cmath>
#include <vector>
#include <algorithm>
#include <stack>
#include <queue>
#include <deque>
#include <iomanip>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

void dfs(vector<vector<ll>>& gr, vector<bool>& used, ll v, vector<ll>& t) {
    used[v] = true;
    for (auto i : gr[v]) {
        if (!used[i]) dfs(gr, used, i, t);
    }
    t.push_back(v);
}

void doTopSort(vector<vector<ll>>& gr, vector<bool>& used, vector<ll>& ans) {
    ans.clear();
    for (int i = 0; i < gr.size(); i++) {
        if (!used[i]) dfs(gr, used, i, ans);
    }
    reverse(ans.begin(), ans.end());
}

int main()
{
   /* ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;
        vector <vector<ll>> gr(n);
        vector<pair<ll, ll>> p(m);
        for (int i = 0; i < m; i++) {
            ll x, y;
            cin >> x >> y;
            x--; y--;
            p[i] = { x, y };
            gr[x].push_back(y);
        }
        vector<bool> used(n);
        vector<ll> ans;
        doTopSort(gr, used, ans);
        map<ll, ll>dict;
        for (int i = 0; i < ans.size(); i++) {
            dict[ans[i]] = i;
        }
        ll cnt = 0;
        for (int i = 0; i < m; i++) {
            if (dict[p[i].first] < dict[p[i].second]) cnt++;
        }
        if (cnt >= m / 2) {
            for (auto i : ans) cout << ++i << " ";
            cout << endl;
        }
        else cout << -1 << endl;*/
    //}
    ll n, e;
    cin >> n >> e;
    vector<string> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    map<char, ll> dict;
    vector<string> pr;
    for (int i = 0; i < n; i++) {
        bool fl = 0;
        if (a[i].size() == 1) dict[a[i][0]] = 100000;
        for (int j = 0; j < a[i].size()-1; j++) {
            if (a[i][j] != a[i][j + 1]) {
                dict[a[i][j]] += j+1;
                fl = 1;
                break;
            }
        }
        if (!fl) dict[a[i][0]] = 100000;
    }
    char ans = '$';
    ll mini = 100000000000;
    for (char i = 'a'; i < 'a' + e; i++) {
        if (mini > dict[i]) {
            mini = dict[i];
            ans = i;
        }
    }
    if (mini >= 10000) {
        cout << "NO" << endl;
    }
    else {
        for (int i = 0; i < mini + 1; i++) cout << ans;
        cout << endl;
    }
    return 0;
}

