#include <bits/stdc++.h>

#define int long long
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using ll = long long;
using ld = long double;

using namespace std;

vector<vector<int>> g;
vector<int> tin;
vector<int> seen;

int timer;

void dfs(int v){
    seen[v] = 1;
    tin[v] = timer++;

    for(auto& to : g[v]){
        if(seen[to]) continue;

        dfs(to);
    }
}

void solve(){
    int n, m;

    cin >> n >> m;

    vector<pair<int, int>> edges(m);

    g.assign(n, vector<int>());
    tin.assign(n, 0);
    seen.assign(n, 0);

    timer = 0;

    for(int i = 0 ; i < m; ++i){
        int x, y;

        cin >> x >> y;

        --x; --y;

        edges[i] = {x, y};

        g[x].push_back(y);
    }

    dfs(0);

    vector<pair<int, int>> topsort(n);

    for(int i = 0; i < n; ++i){
        topsort[i] = {tin[i], i};
    }

    sort(all(topsort));

    int cnt = 0;

    for(int i = 0; i < m; ++i){
        if(tin[edges[i].first] < tin[edges[i].second]){
            ++cnt;
        }
    }

    if(cnt >= (m - 1) / 2 + 1){
        for(int i = 0; i < n; ++i){
            cout << topsort[i].second + 1 << ' ';
        }

        cout << endl;
    }else{
        cout << -1 << endl;
    }
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;

    cin >> t;

    while(t--){
        solve();
    }

    return 0;
}
