#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef string str;
typedef unsigned long long ull;

#define Rep(i, k, n) for (int i = k; i <= n; i++)
#define RepR(i, k, n) for (int i = k; i >= n; i--)
#define PB push_back
#define vi vector <int>
#define vll vector <ll>
#define pi pair<int>
#define pll pair<ll>
#define vpi vector <pi>
#define vpll vector <pll>
#define UST unordered_set
#define UMP unordered_map
#define vvi vector <vi>
#define vvll vector <vll>
#define vs vector <str>
#define vb vector <bool>

const ll INF = 1e9 + 7;

ll binpow(ll a, ll b) {
    if (b == 0) return 1;
    if (b == 1) return a;
    ll u = binpow(a, b / 2);
    if (b % 2)
        return (u * u * a) % INF;
    return (u * u) % INF;
}

void dfs(int ver, vvi &v, vb &used, vi &ans) {
    used[ver] = true;
    for (auto x : v[ver]) {
        if (!used[x]) {
            dfs(x, v, used, ans);
        }
    }
    ans.PB(ver);
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);

    int t, n, m, u, v1;
    cin >> t;
    Rep(o, 1, t) {
        cin >> n >> m;
        vvi v(n + 1);
        vb used(n + 1, false);
        vi ans = {};
        Rep(i, 1, m) {
            cin >> u >> v1;
            v[u].PB(v1);
        }
        if (m > 2 * n - 2) {
            cout << "-1\n";
            continue;
        }
        Rep(i, 1, n) {
            if (!used[i]) dfs(i, v, used, ans);
        }
        reverse(ans.begin(), ans.end());

        for (auto x : ans) cout << x << " ";
        cout << "\n";
    }
    return 0;
}
/*
2
3 3
1 2
2 3
3 1
5 6
4 2
2 1
4 3
1 4
3 2
3 5

1
4 9
1 2
2 3
3 4
4 1
4 2
4 3
3 2
3 1
2 1
*/

