﻿
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <deque>
#include <stack>
#include <string>
#include <cstdint>

#define en '\n'
#define isz(x) int(x.size())
#define ins insert
#define pb push_back
#define str string
#define vec vector
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define fin(x) for (auto &it : x) cin >> it
#define fout(x) for (auto &it : x) cout << it << ' '; cout << en

using namespace std;
using ll = long long;
using ld = long double;
using i64 = int64_t;
using i32 = int32_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using V = vector<T>;
using vi = V<int>;
using vl = V<ll>;
using vpii = V<pii>;
using vpll = V<pll>;
using vld = V<ld>;
using vb = V<bool>;
using vc = V<char>;
using vs = V<str>;
using ull = unsigned long long;

template<typename T>
using pqsmalleststart = priority_queue<T, vector<T>, greater<T>>;

template<typename T>
using pqmaximumstart = priority_queue<T, vector<T>, less<T>>;


vector<vector<int>> g;

vi path;
vb used;

void dfs(int v, int p) {
    used[v] = true;
    for (int next : g[v]) {
        if (next == p) continue;
        if (!used[next]) dfs(next, v);
    }
    path.pb(v);
}

void solve() {
    int n, m; cin >> n >> m;

    g = vector<vector<int>>(n + 1);
    used = vb(n + 1);
    path.clear();
    vector<pii> e(m);
    vi cnt(n + 1);
    vi cnt2(n + 1);

    for (size_t i = 0; i < m; i++)
    {
        int from, to; cin >> from >> to;
        cnt[from]++;
        cnt2[to]++;
        g[from].pb(to);
        e[i] = make_pair(from, to);
    }

    vi vert(n);
    for (size_t i = 0; i < n; i++)
    {
        vert[i] = i + 1;
    }
    sort(all(vert), [&](int a, int b) {
        return cnt[a] > cnt[b] || cnt[a] == cnt[b] && cnt2[a] < cnt2[b];
        });


    for (int v : vert) {
        if (used[v]) continue;
        dfs(v, v);
    }
    reverse(all(path));
    vi pos(n + 1);
    for (size_t i = 0; i < isz(path); i++)
    {
        pos[path[i]] = i;
    }
    int c = 0;
    //cout << "---------" << en;
    for (size_t i = 0; i < m; i++)
    {
        int from = e[i].first;
        int to = e[i].second;
        if (pos[from] < pos[to]) {
            c++;
            //cout << from << ' ' << to << en;
        }
    }
    if (c >= (m + 1) / 2) {
        fout(path);
    }
    else {
        cout << -1 << en;
        //fout(path);
    }
}

void multiSolve() {
    int t_; cin >> t_; while (t_--) {
        solve();
    }
}

void brute() {

}

void trash() {

}

int main()
{
    ios_base::sync_with_stdio(false);  cin.tie(0); cout.tie(0);
    //cout.setf(ios::fixed); cout.precision(20);

    //trash();
    //brute();
    //solve();
    multiSolve();
}