﻿
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <deque>
#include <stack>
#include <string>
#include <cstdint>

#define en '\n'
#define isz(x) int(x.size())
#define ins insert
#define pb push_back
#define str string
#define vec vector
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define fin(x) for (auto &it : x) cin >> it
#define fout(x) for (auto &it : x) cout << it << ' '; cout << en

using namespace std;
using ll = long long;
using ld = long double;
using i64 = int64_t;
using i32 = int32_t;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using V = vector<T>;
using vi = V<int>;
using vl = V<ll>;
using vpii = V<pii>;
using vpll = V<pll>;
using vld = V<ld>;
using vb = V<bool>;
using vc = V<char>;
using vs = V<str>;
using ull = unsigned long long;

template<typename T>
using pqsmalleststart = priority_queue<T, vector<T>, greater<T>>;

template<typename T>
using pqmaximumstart = priority_queue<T, vector<T>, less<T>>;

void solve() {
    int n, e; cin >> n >> e;
    vs v(n); fin(v);
    vi have(e);
    set<int> good;
    for (size_t i = 0; i < e; i++)
    {
        good.insert(i);
    }
    for (size_t i = 0; i < n; i++)
    {
        int cnt = 0;
        bool bad = true;
        for (char c : v[i])
        {
            if (c == v[i][0]) cnt++;
            else
            {
                break; bad = false;
            }
        }
        have[v[i][0] - 'a'] = max(have[v[i][0] - 'a'], cnt);
        if (bad) good.erase(v[i][0] - 'a');
    }
    str ans = "";
    int z = -1;
    for (int x : good) {
        if (z == -1 || have[z] > have[x]) {
            z = x;
        }
    }
    if (z != -1) {
        char c = 'a';
        c += z;
        ans = string(have[z] + 1, c);
    }
    if (ans.empty()) {
        cout << "NO" << en;
        return;
    }
    cout << ans << en;
}

void multiSolve() {
    int t_; cin >> t_; while (t_--) {
        solve();
    }
}

void brute() {

}

void trash() {

}

int main()
{
    ios_base::sync_with_stdio(false);  cin.tie(0); cout.tie(0);
    //cout.setf(ios::fixed); cout.precision(20);

    //trash();
    //brute();
    solve();
    //multiSolve();
}