#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

vector<int> h;
vector<int> p;

bool comp(pair<int, int> p1, pair<int, int> p2){
    int i1 = p1.second;
    int i2 = p2.second;
    return h[i1] < h[i2] || (h[i1] == h[i2] && (p[i1] - h[i1] < p[i2] - h[i2]));
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for(int iii = 0; iii < t; iii++){
        int n;
        cin >> n;
        set<int> min;

        h = vector<int> (n, 0);
        p = vector<int> (n, 0);
        for(int i = 0; i < n; i++){
            cin >> h[i];
        }
        for(int i = 0; i < n; i++){
            cin >> p[i];
        }
        vector<pair<int, int>> v1(n);
        for (int i = 0; i < n; ++i) {
            v1[i] = make_pair(h[i], i);
        }
        vector<pair<int, int>> v2(n);
        for (int i = 0; i < n; ++i) {
            v2[i] = make_pair(p[i] - h[i], i);
        }
        sort(v2.begin(), v2.end());
        sort(v1.begin(), v1.end(), comp);

        bool tr = true;
        for (int i = 0; i < n; ++i) {
            if (v1[i].second != v2[i].second || v2[i].first < 0) tr = false;
        }
        if (tr) {
            cout << v2.back().first << endl;
        } else {
            cout << -1 << endl;
        }
    }
}
