#include<iostream>
#include<fstream>
#include<vector>
#include<algorithm>
#include<cmath>
#include<string>
#include<queue>
#include<stack>
#include<set>
#include<map>

using namespace std;
typedef long long ll;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll t;
    cin >> t;

    for (ll k = 0; k < t; ++k)
    {
        int n;
        cin >> n;
        vector<pair<int, int>> mountain(n);
        vector<int> delta(n);
        for (int j = 0; j < n; ++j)
            cin >> mountain[j].second;
        for (int j = 0; j < n; ++j)
            cin >> mountain[j].first;
        sort(mountain.rbegin(), mountain.rend());
        bool valid = true;
        for (int i = 1; i < n; ++i)
            if (mountain[i - 1] < mountain[i])
                valid = false;
        for (int i = 0; i < n; ++i)
        {
            delta[i] = mountain[i].first - mountain[i].second;
            mountain[i].first -= delta[i];
            if (delta[i] < 0)
                valid = false;
        }
        for (int i = 1; i < n; ++i)
            if (delta[i - 1] < delta[i] || mountain[i-1].first < mountain[i].first)
                valid = false;
        if (valid)
            cout << delta[0] << '\n';
        else
            cout << "-1\n";
    }

    return 0;
}