﻿#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <deque>
#include <stack>
#include <list>
#include <bitset>
#include <string>

#define num long long

using namespace std;



void solution() {
	num n, m;
	cin >> n >> m;

	set<pair<num, num>> elems;
	vector<set<num>> revribs(n);
	vector<num> size(n);
	vector<num> ans;
	num k = 0;

	for (num i = 0; i < m; i++) {
		num f, t;
		cin >> f >> t;
		f -= 1;
		t -= 1;

		revribs[t].emplace(f);
		size[f] = 1 + size[f];
	}

	for (num i = 0; i < n; i++) {
		pair<num, num> elem = { size[i], i };
		elems.emplace(elem);
	}

	for (num i = 0; i < n; i++) {
		set<pair<num, num>>::const_iterator point = elems.begin();
		num now = (*point).second;
		k += (*point).first;
		elems.erase(point);

		for (num elem : revribs[now]) {

			pair<num, num> befelm = { size[elem], elem };
			size[elem] -= 1;
			pair<num, num> elm = { size[elem], elem };

			elems.erase(befelm);
			elems.emplace(elm);
		}


		ans.push_back(now + 1);
	}

	if (k > n / 2 + n % 2) {
		for (num i = 0; i < n; i++) {
			cout << ans[i] << " ";
		}
	}
	else {
		for (num i = n - 1; i > -1; i--) {
			cout << ans[i] << " ";
		}
	}

	cout << "\n";
}



num search(num x, vector<num> nums) {
	num left = 0; num right = nums.size();
	num mid = (left + right) / 2;
	while (left + 1 < right) {
		if (nums[mid] <= x) {
			left = mid;
		}
		else {
			right = mid;
		}
	}
	return left;

}
 
int main() {
	ios_base::sync_with_stdio(false);
	num n = 1;
	cin >> n;
	while (n--) {
		solution();
	}

	return 0;
}
