#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <string>
#include<bitset>
#include<cassert>
#include<random>

#define int long long
#define sigma signed
//#define double long double

using namespace std;

mt19937_64 rnd(87086040);

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);

    for (int i = 0; i < n; ++i) cin >> a[i];
    for (int i = 0; i < n; ++i) cin >> b[i];

    for (int i = 0; i < n; ++i) {
        a[i] = b[i] - a[i];
        if (a[i] < 0) {
            cout << -1 << '\n';
            return;
        }
    }

    set<pair<int, int>> help;

    for (int i = 0; i < n; ++i) {
        help.insert({ b[i], a[i] });
    }

    int sub = 0;
    int last = -1e9;

    for (auto now : help) {
        now.second -= sub;

        if (now.second < 0) {
            cout << -1 << '\n';
            return;
        }

        if (now.first - last < now.second) {
            cout << -1 << '\n';
            return;
        }

        sub += now.second;
        last = now.first;
    }

    cout << sub << '\n';
}

sigma main()
{
#ifndef LOCAL
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#else
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // ONLINE_JUDGE

    int t = 1;
    cin >> t;

#ifdef LOCAL
    auto start = clock();
#endif // ONLINE_JUDGE
    while (t-- > 0) {
            solve();
    }
#ifdef LOCAL
    auto end = clock();

    cout << "\nWorking time: " << end - start << '\n';
    cout << "\nHUI\n";
#endif
}
