﻿#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <string>

#define ll long long

using namespace std;

const ll MOD = 998244353;

ll get_num(vector<int>& a) {
    ll ans = 0;
    bool swap = 0;
    for (int i = a.size() - 1; i >= 0; i--) {
        if (!swap) {
            ans = (ans * 3 + (ll)a[i]) % MOD;
        }
        else {
            ans = (ans * 3 + (ll)(2 - a[i])) % MOD;
        }
        if (a[i] == 1) {
            swap = !swap;
        }
    }

    return ans;
}

void solve() {
    int n;
    cin >> n;

    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        a[i]--;
    }

    for (int i = 0; i < n; i++) {
        cin >> b[i];
        b[i]--;
    }

    ll a1 = get_num(a),
       b1 = get_num(b);

    bool s = 0;
    for (int i = n - 1; i >= 0; i--) {
        if (b[i] > a[i] && !s || b[i] < a[i] && s) {
            swap(a1, b1);
            break;
        }
        else if (b[i] != a[i]) {
            break;
        }

        if (b[i] == 1) {
            s = !s;
        }
    }

    ll ans = (MOD + a1 - b1) % MOD;
    cout << ans << '\n';
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}