﻿#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <math.h>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <deque>
#include <queue>
#include <bitset>

#define all(v) v.begin(),v.end()

using namespace std;
typedef long long ll;
const long long MOD = 998244353;
const long long MAXN = 100000;

void start() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    //cout << fixed << setprecision(9);

#ifdef TEAM
    freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
}

ll gcd(ll x, ll y) {
    while (y) {
        x %= y;
        swap(x, y);
    }
    return x;
}

ll binpow(ll a, ll k, ll mod = 1e9 + 7) {
    ll res = 1;
    ll t = a;
    while (k) {
        if (k % 2)
            res = (res * t) % mod;
        t = (t * t) % mod;
        k /= 2;
    }
    return res;
}

ll rev(ll a, ll mod = MOD) {
    return binpow(a, mod - 2, mod);
}

/*
ll fact[MAXN];
ll revf[MAXN];
void prec() {
    ll c=1;
    fact[0] = 1;
    for (size_t i = 1; i < MAXN; ++i)
    {
        fact[i] = (fact[i - 1] * i)%MOD;
    }
    revf[MAXN - 1] = rev(fact[MAXN - 1]);
    for (int i = MAXN - 2; i >= 0; i--)
    {
        revf[i] = (revf[i + 1] * (i+1)) % MOD;
    }
}
*/

void solve() {
    int n, a, b;
    cin >> n >> a >> b;
    map<int, vector<int>> d;
    int x, y;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        d[x].push_back(y);
    }
    map<int, ll> ans[2];
    ans[0][0] = 0;
    for (auto& [num, v] : d) {
        sort(all(v));
        for (int i = 0; i <= v.size(); ++i) {
            ll dist = (ll)v.size() - i;
            if (i > 0) {
                dist -= (v[i - 1] <= 2 * i - 1 ? 0 : v[i - 1] / 2 - i + 1);
            }
            for (auto [num2, c] : ans[0]) {
                if ((num2 + dist) <= abs(n)) {
                    if (ans[1].count(num2 + dist)) {
                        ans[1][num2 + dist] = min(ans[1][num2 + dist], c + v.size() - i);
                    }
                    else {
                        ans[1][num2 + dist] = c + v.size() - i;
                    }
                }
            }
        }
        swap(ans[0], ans[1]);
        ans[1].clear();
    }
    ll res = n;
    for (auto e : ans[0]) {
        if (e.first >= 0) {
            res = min(res, (ll)e.second);
        }
    }
    cout << res << endl;
}

int main()
{
    
    start();
    ll t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
