#include <iostream>
#include <vector>
#include <list>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <stack>
#include <bitset>
#include <algorithm>
#include <sstream>
#include <iomanip>
#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <tuple>
#include <random>
#include <chrono>

using namespace std;

#define ln "\n"
#define pb push_back
#define mp make_pair
#define ins insert
#define sz(x) (int)x.size()
#define All(x) (x).begin(), (x).end()
#define Allf(x) (x).begin() + 1, (x).end()

#define fi(a, b) for(auto i = a; i <= b; i++)
#define fj(a, b) for(auto j = a; j <= b; j++)
#define fo(a, b) for(auto o = a; o <= b; o++)
#define fw(a, b) for(auto w = a; w <= b; w++)

#define fdi(a, b) for(auto i = a; i >= b; i--)
#define fdj(a, b) for(auto j = a; j >= b; j--)
#define fdo(a, b) for(auto o = a; o >= b; o--)
#define fdw(a, b) for(auto w = a; w >= b; w--)

#define fx( A) for(auto& x: (A) )
#define fy( A) for(auto& y: (A) )
#define fz( A) for(auto& z: (A) )

typedef long long ll;
typedef long double ld;
typedef vector<int> vi;
typedef vector<long long> vll;
typedef vector<vi> vvi;
typedef pair<int, int> pii;

template<typename T>
ostream& operator<<(ostream& os, vector<T> v){
    fx( v) {
        os << x << ' ';
    }
    return os;
}

template<typename T>
ostream& operator<<(ostream& os, set<T> v){
    fx( v) {
        os << x << ' ';
    }
    return os;
}

template<typename T1,typename T2>
ostream& operator<<(ostream& os, pair<T1,T2> v){
    
    os << "(" << v.first << ", " << v.second << ")";
    
    return os;
}

#ifdef LOCAL
#define dbg(x) { cerr << __LINE__ << "\t" << #x << ": " <<  (x) << ln; }
#else
#define dbg(x) {}
#endif

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const int MAX = 10'000;

int n;
int m;
vector<string> v;

bool can(char t,int m){
    int ans = 0;
    fi(1,n){
        bool f = 1;
        fj(0,sz(v[i]) - 1){
            if(v[i][j] != t){
                f = 0;
                break;
            }else{
                ans++;
            }
        }
        if(f)return true;
    }
    return (ans >= m);
}

void solve() {
    int ans = MAX + 1;
    char t = -1;
    fi('a','a' + m - 1){
        int l = -1,r = MAX + 1;
        if(can(i,r))continue;
        while(l + 1 < r){
            int m = (l + r)/2;
            if(can(i,m))l = m;
            else r = m;
        }
        if(ans > r){
            ans = r;
            t = i;
        }
    }
    if(t != -1){
        fi(1,ans){
            cout << t;
        }
    }else{
        cout << "NO" << ln;

    }

}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif

    cin >> n >> m;
    v = vector<string>(n + 1);
    fi(1, n) cin >> v[i];

    solve();

    return 0;

}