#include<bits/stdc++.h>

using namespace std;

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

bool check(std::vector<int>& sp, int n, int val) {
    std::vector<int> delta(n);
    for (int ind = 0; ind < n; ++ind) {
        delta[ind] = sp[ind] - val;
        if (delta[ind] < 0) {
            return false;
        }
    }
    for (int pow = 0; pow < 30; ++pow) {
        for (int ind = 0; ind < n; ++ind) {
            if (delta[ind] % 2 == 1) {
                delta[ind] -= 1;
                delta[(ind + 1) % n] -= 2;
            }
        }
        for (int ind = 0; ind < n; ++ind) {
            if (delta[ind] < 0) {
                return false;
            }
        }
        for (int ind = 0; ind < n; ++ind) {
            delta[ind] /= 2;
        }
    }
    return true;
}

void solve() {
    int n;
    std::cin >> n;
    std::vector<int> sp(n);
    for (int ind = 0; ind < n; ++ind) {
        std::cin >> sp[ind];
    }
    int l = 0;
    int r = 400'000'000 + 10;
    while(r - l > 1) {
        int mid = (r + l) / 2;
        if (check(sp, n, mid * 3 + 2) || check(sp, n, mid * 3 + 1) || check(sp, n, mid * 3)) {
            l = mid;
        } else {
            r = mid;
        }
    }
    if (check(sp, n, 3 * l + 2)) {
        std::cout << 3 * l + 2 << "\n";
    } else if (check(sp, n, 3 * l + 1)) {
        std::cout << 3 * l + 1 << "\n";
    } else {
        std::cout << 3 * l << "\n";
    }
    return;
}

int32_t main() {
    IOSync();
    int tests = 1;
    std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
