#include<bits/stdc++.h>

using namespace std;

void IOSync() {
    std::ios_base::sync_with_stdio(0);
    std::cin.tie(0);
    std::cout.tie(0);
}

const int kMaxN = 100 + 5;
const long long kMod = 998244353;
const int kMaxPow2 = 20;
int pow2[kMaxPow2];

void precalc() {
    pow2[0] = 1;
    for (int x = 1; x < kMaxPow2; ++x) {
        pow2[x] = pow2[x - 1] * 2;
    }
}

void solve() {
    int n, m, k;
    std::cin >> n >> m >> k;
    std::string str;
    std::cin >> str;
    int num = 0;
    for (int i = 0; i < k; ++i) {
        num *= 2;
        num += str[i] - '0';
    }
    std::vector<std::vector<long long> > dp(pow2[pow2[k + 1]], std::vector<long long>(pow2[k]));
    std::vector<std::vector<long long> > next(pow2[pow2[k + 1]], std::vector<long long>(pow2[k]));
    for (int cur = 0; cur < (1 << k); ++cur) {
        dp[0][cur] = 1;
    }
    for (int len = k; len < std::min(n, m); ++len) {
        for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
            for (int cur = 0; cur < (1 << k); ++cur) {
                for (int bit = 0; bit < 2; ++bit) {
                    int new_cur = (cur * 2 + bit) % pow2[k];
                    int new_mask = (mask | pow2[cur * 2 + bit]);
                    next[new_mask][new_cur] = (next[new_mask][new_cur] + dp[mask][cur]) % kMod;
                }
            dp[mask][cur] = 0;
            }
        }
        dp.swap(next);
    }
    std::vector<int> copy_sm(pow2[(1 << (k + 1))]);
    for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
        for (int cur = 0; cur < (1 << k); ++cur) {
            bool fl = (cur == num);
            for (int bit = 0; bit < (1 << (k + 1)); ++bit) {
                if ((mask & (1 << bit)) != 0) {
                    if ((bit >> 1) == num) {
                        fl = true;
                        break;
                    }
                    if ((bit >> 1 << 1) == (num << 1)) {
                        fl = true;
                        break;
                    }
                }
            }
            if (fl) {
                //std::cout << "ADDED: " << mask << " " << cur << " - " << dp[mask][cur] << std::endl;
                copy_sm[mask] = (copy_sm[mask] + dp[mask][cur]) % kMod;
            }
        }
    }
    for (int len = std::min(n, m); len < std::max(n, m); ++len) {
        for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
            for (int cur = 0; cur < (1 << k); ++cur) {
                for (int bit = 0; bit < 2; ++bit) {
                    int new_cur = (cur * 2 + bit) % pow2[k];
                    int new_mask = (mask | pow2[cur * 2 + bit]);
                    next[new_mask][new_cur] = (next[new_mask][new_cur] + dp[mask][cur]) % kMod;
                }
            dp[mask][cur] = 0;
            }
        }
        dp.swap(next);
    }
    std::vector<int> sm(pow2[(1 << (k + 1))]);
    for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
        for (int cur = 0; cur < (1 << k); ++cur) {
            bool fl = (cur == num);
            for (int bit = 0; bit < (1 << (k + 1)); ++bit) {
                if ((mask & (1 << bit)) != 0) {
                    if ((bit >> 1) == num) {
                        fl = true;
                        break;
                    }
                    if ((bit >> 1 << 1) == (num << 1)) {
                        fl = true;
                        break;
                    }
                }
            }
            if (fl) {
                //std::cout << "ADDED: " << mask << " " << cur << " - " << dp[mask][cur] << std::endl;
                sm[mask] = (sm[mask] + dp[mask][cur]) % kMod;
            }
        }
    }
    for (int bit = 0; bit < (1 << (k + 1)); ++bit) {
        for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
            if ((mask & (1 << bit)) != 0) {
                sm[mask] = (sm[mask] + sm[mask ^ (mask & pow2[bit])]) % kMod;
            }
        }
    }
    int answer = 0;
    for (int mask = 0; mask < pow2[(1 << (k + 1))]; ++mask) {
        answer = (answer + copy_sm[mask] * sm[(pow2[(1 << (k + 1))] - 1) ^ (mask)]) % kMod;
    }
    std::cout << answer << std::endl;
    return;
}

int32_t main() {
    IOSync();
    precalc();
    int tests = 1;
    // std::cin >> tests;
    while(tests--) {
        solve();
    }
    return 0;
}
