﻿#include <iostream>
#include <algorithm>
#include <iomanip>
#include <vector>

using ll = long long;
using db = double;
const int inf = 10000000009;
using namespace std;
void solve() {
    int n;
    cin >> n;
    vector <pair<int, int>> h(n);
    for (int i = 0; i < n; i++) {
        cin >> h[i].first;
    }
    
    for (int i = 0; i < n; i++) {
        cin >> h[i].second;
    }
    sort(h.begin(), h.end());
    pair<int, int> prev = { 0, 0 };
    for (auto cur : h) {
        int a1 = cur.first - prev.first;
        int a2 = cur.second - prev.second;
        if (a2 < a1) {
            cout << -1 << endl;
            return;
        }
        /*if (prev.first < cur.first) {
            if (prev.second >= cur.second) {
                cout << -1 << endl;
                return;
            }
        }
        if (prev.first <= cur.first) {
            if (prev.second > cur.second) {
                cout << -1 << endl;
                return;
            }
        }*/
        prev = cur;
    }
    int res = 0;
    for (auto cur : h) {
        int k = cur.second - cur.first;
        if (k < 0) {
            cout << -1 << endl;
            return;
        }
        res = max(res, k);
    }
    cout << res << endl;
}

int main(){

#ifdef DEBUG
    auto f = freopen("test.txt", "r", stdin);
    cout << "Debug Mode" << endl;
#endif // DEBUG
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}


