import sys


input = lambda: sys.stdin.readline().strip()
# print = lambda x: sys.stdout.write(x + '\n')


read_ints = lambda: map(int, input().split())

def get_next(i, n):
    return i + 1 if i != n - 1 else 0


def get_prev(i, n):
    return i - 1 if i != 0 else n - 1


def check(diff_arr, zero_pos):
    n = len(diff_arr)
    for i in range(zero_pos + 1, n):
        next = get_next(i, n)
        diff_arr[next] -= 2 * diff_arr[i]
        if diff_arr[next] < 0:
            return False
    for i in range(0, zero_pos - 1):
        diff_arr[i + 1] -= 2 * diff_arr[i]
        if diff_arr[i + 1] < 0:
            return False
    if zero_pos == 0:
        return diff_arr[-1] == 0
    return diff_arr[zero_pos - 1] == 0


def solve_0(n, a, mn, d, mn_pos):
    if (sum(a) - n * mn) % 3 != 0:
        return False
    for i in range(n):
        d[i] = a[i] - mn

    return check(d, mn_pos)


def solve_1(n, a, mn, d, mn_pos):
    if mn == 0:
        return False
    mn -= 1
    a[mn_pos] -= 1
    next = get_next(mn_pos, n)
    next_val = a[next]
    a[next] = max(0, a[next] - 2)
    res = solve_0(n, a, mn, d, mn_pos)
    a[mn_pos] += 1
    a[next] = next_val
    return res



def solve_22(n, a, mn, d, mn_pos):
    mn -= 2
    prev = get_prev(mn_pos, n)
    a[mn_pos] -= 2
    a[prev] -= 1
    res = solve_0(n, a, mn, d, mn_pos)
    a[mn_pos] += 2
    a[prev] += 1
    return res


def solve_21(n, a, mn, d, mn_pos):
    mn -= 2
    next = get_next(mn_pos, n)
    a[mn_pos] -= 2
    a[next] = max(0, a[next] - 4)
    return solve_0(n, a, mn, d, mn_pos)



def solve():
    n = int(input())
    a = list(read_ints())
    mn = min(a)
    mn_pos = a.index(mn)
    d = [0] * n
    res = 0
    if solve_0(n, a, mn, d, mn_pos):
        res = mn
    elif solve_1(n, a, mn, d, mn_pos):
        res = mn - 1
    elif mn > 1:
        if solve_22(n, a, mn, d, mn_pos) or solve_21(n, a, mn, d, mn_pos):
            res = mn - 2

    print(res)




t = 1
t = int(input())
for _ in range(t):
    solve()
