from math import gcd


def solve(n, h, p):
    values = list()
    for h_i, p_i in zip(h, p):
        diff = p_i - h_i
        if diff < 0:
            return -1
        if diff > 0:
            values.append(diff)
    if not values:
        return 0
    g = 1
    for value in values:
        g = gcd(g, value)
    return max(values) // g


t = int(input())
for _ in range(t):
    n = int(input())
    h = list(map(int, input().split()))
    p = list(map(int, input().split()))
    print(solve(n, h, p))
