#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <set>
#include <map>


using namespace std;

typedef long long ll;

void solve();

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
		cout << "\n";
	}
}


void solve() {
	int n, e;
	cin >> n >> e;
	vector<string> l(n);
	vector<bool> infinite(e);
	vector<int> maxLen(e);

	for (int i = 0; i < n; ++i) {
		cin >> l[i];
		int curr = 1;

		for (int j = 1; j < l[i].size(); ++j) {
			if (l[i][j] == l[i][j - 1]) {
				++curr;
			}
			else {
				break;
			}
		}

		if (curr == l[i].size()) {
			infinite[l[i][0] - 'a'] = true;
		}
		else {
			maxLen[l[i][0] - 'a'] += curr;
		}
	}

	int ans = 1e9;
	bool isPos = false;

	for (int i = 0; i < e; ++i) {
		if (!infinite[i]) {
			isPos = true;

			ans = min(ans, maxLen[i]);
		}
	}

	if (isPos) {
		for (int i = 0; i < e; ++i) {
			if (maxLen[i] == ans) {
				cout << string(ans + 1, char('a' + i));
				return;
			}
		}
	}
	else {
		cout << "NO";
	}
}