def execute():
    n = int(input())
    data = sorted(zip(map(int, input().split()), map(int, input().split())), key=lambda val: (val[1], -val[0]))

    actions = 0
    left_max = 0
    for i, (x1, x2) in enumerate(data):
        if x1 > x2 or x1 < left_max:
            print(-1)
            return

        left_max = max(left_max, x1)
        actions += (x2 - x1) - actions
    print(actions)


def main():
    t = int(input())
    for _ in range(t):
        execute()


main()
