﻿#define _CRT_SECURE_NO_WARNINGS

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma comment(linker, "/STACK:67108864")

#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <random>
#include <string>

#define ll long long

using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<int> diff(n);
    int absum = 0;
    for (int i = 0; i < n; ++i) {
        diff[i] = a[i] - a[(i + 1) % n];
        absum += abs(diff[i]);
    }
    int prevabsum = 0;
    int prevabsumcnt = 0;
    while (absum > 0) {
        if (prevabsum == absum) {
            prevabsumcnt++;
        } else {
            prevabsum = absum;
            prevabsumcnt = 1;
        }
        if (prevabsumcnt >= 8) {
            cout << 0 << endl;
            return;
        }
        absum = 0;
        for (int i = n - 1; i >= 0; --i) {
            if (diff[i] > 0) {
                int d = diff[i] / 2 + diff[i] % 2;
                diff[i] -= d * 2;
                diff[(i - 1 + n) % n] += d;
                diff[(i - 2 + n) % n] += d;
                a[i] -= d * 2;
                a[(i - 1 + n) % n] -= d;
            }
        }
        for (int i = 0; i < n; ++i) {
            absum += abs(diff[i]);
        }
    }
    if (absum == 0) {
        cout << max(a[0], 0) << endl;
    } else {
        cout << 0 << endl;
    }
}

signed main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}